package com.cnbm.basic.excel;

import cn.afterturn.easypoi.excel.annotation.Excel;
import lombok.Data;

import java.time.LocalDateTime;

/**
 * 过程检验-工艺-检验参数 关系表 
 *
 * @author why
 * @since  2022-09-01
 */
@Data
public class FeaturesStageProcedureRelationExcel {
    @Excel(name = "ID")
    private Long id;
    @Excel(name = "检验参数id,关联product_features表")
    private Long productFeaturesId;
    @Excel(name = "工序id,关联 working_procedure 表")
    private Long workingProcedureId;
    @Excel(name = "（如果为空就代表4个阶段都不是）检验阶段；1 进货检验、 2 过程检验、 3 成品检验、 4 出货检验")
    private Integer inspectionStage;
    @Excel(name = "备注")
    private String remark;
    @Excel(name = "删除标志，是否有效:1 可用 0不可用")
    private Integer valid;
    @Excel(name = "创建人")
    private Long creatorId;
    @Excel(name = "创建人姓名")
    private String creatorName;
    @Excel(name = "创建时间")
    private LocalDateTime createTime;
    @Excel(name = "更新人")
    private Long updaterId;
    @Excel(name = "更新人姓名")
    private String updaterName;
    @Excel(name = "更新时间")
    private LocalDateTime updateTime;
    @Excel(name = "版本号")
    private Integer version;

}