package com.cnbm.basic.mapper;

import com.cnbm.common.dao.BaseDao;
import com.cnbm.basic.entity.ProductFactoryRelation;
import org.apache.ibatis.annotations.Mapper;

import java.util.List;

/**
 * 产品-工厂 关系表
 *
 * @author why
 * @since 2022-07-27
 */
@Mapper
public interface ProductFactoryRelationMapper extends BaseDao<ProductFactoryRelation> {
	List<Long> getFactoryListByProductId(Long productId);
}