package com.cnbm.basic.mapper;

import com.cnbm.basic.dto.FeaturesProcedureDTO;
import com.cnbm.basic.dto.FeaturesStageProcedureRelationDTO;
import com.cnbm.basic.dto.ProductFeaturesDTO;
import com.cnbm.common.dao.BaseDao;
import com.cnbm.basic.entity.ProductFeatures;
import org.apache.ibatis.annotations.Mapper;

import java.util.List;
import java.util.Map;

/**
 * 产品特性 表
 *
 * @author why
 * @since 2022-07-15
 */
@Mapper
public interface ProductFeaturesMapper extends BaseDao<ProductFeatures> {
	List<ProductFeaturesDTO> getProductFeaturesByProductId(Long id);

	List<FeaturesProcedureDTO> getFeaturesByStageProcedure(Map<String, Object> params);

	List<ProductFeaturesDTO> getFeaturesList(Map<String, Object> params);

	String getControlGraphNameById(Long id);

	List<ProductFeaturesDTO> list();
}