package com.cnbm.basic.service;

import com.cnbm.common.page.PageData;
import com.cnbm.common.service.CrudService;
import com.cnbm.basic.dto.FeaturesStageProcedureRelationDTO;
import com.cnbm.basic.entity.FeaturesStageProcedureRelation;

import java.util.List;
import java.util.Map;

/**
 * 过程检验-工艺-检验参数 关系表 
 *
 * @author why
 * @since  2022-09-01
 */
public interface IFeaturesStageProcedureRelationService extends CrudService<FeaturesStageProcedureRelation, FeaturesStageProcedureRelationDTO> {
    PageData<FeaturesStageProcedureRelationDTO> page (Map<String, Object> params);

    FeaturesStageProcedureRelationDTO get(Long id);

    void save(FeaturesStageProcedureRelationDTO dto);

    void update(FeaturesStageProcedureRelationDTO dto);

    void delete(Long[] ids);

    void batchInsert(FeaturesStageProcedureRelationDTO[] lists);

    void deleteByStageProcedure(Map<String, Object> params);
}
