package com.cnbm.basic.service;

import com.cnbm.common.page.PageData;
import com.cnbm.common.service.CrudService;
import com.cnbm.basic.dto.PlatformDTO;
import com.cnbm.basic.entity.Platform;

import java.util.List;
import java.util.Map;

/**
 * 站点表
 *
 * @author why
 * @since  2022-07-13
 */
public interface IPlatformService extends CrudService<Platform, PlatformDTO> {
    PageData<PlatformDTO> page (Map<String, Object> params);

    PlatformDTO get(Long id);

    void save(PlatformDTO dto);

    void update(PlatformDTO dto);

    void delete(Long[] ids);

    List<PlatformDTO> list();

    boolean changeStatus(Long id);
}