package com.cnbm.basic.service;

import com.cnbm.common.page.PageData;
import com.cnbm.common.service.CrudService;
import com.cnbm.basic.dto.ProductDTO;
import com.cnbm.basic.entity.Product;
import com.cnbm.common.vo.IdVo;

import java.util.List;
import java.util.Map;

/**
 * 产品 表
 *
 * @author why
 * @since  2022-07-11
 */
public interface IProductService extends CrudService<Product, ProductDTO> {
    PageData<ProductDTO> page (Map<String, Object> params);

    ProductDTO get(Long id);

    IdVo add(ProductDTO dto);

    void update(ProductDTO dto);

    void delete(Long[] ids);

    boolean changeStatus(Long id);

    List<ProductDTO> list();

}