package com.cnbm.basic.service;

import com.cnbm.common.page.PageData;
import com.cnbm.common.service.CrudService;
import com.cnbm.basic.dto.TeamDTO;
import com.cnbm.basic.entity.Team;

import java.util.List;
import java.util.Map;

/**
 * 班组 表
 *
 * @author why
 * @since  2022-07-13
 */
public interface ITeamService extends CrudService<Team, TeamDTO> {
    PageData<TeamDTO> page (Map<String, Object> params);

    TeamDTO get(Long id);

    void save(TeamDTO dto);

    void update(TeamDTO dto);

    void delete(Long[] ids);

    List<TeamDTO> list();
}