package com.cnbm.basic.service;

import com.cnbm.common.page.PageData;
import com.cnbm.common.service.CrudService;
import com.cnbm.basic.dto.WorkingProcedureDTO;
import com.cnbm.basic.entity.WorkingProcedure;

import java.util.List;
import java.util.Map;

/**
 * 工序 表
 *
 * @author why
 * @since  2022-07-15
 */
public interface IWorkingProcedureService extends CrudService<WorkingProcedure, WorkingProcedureDTO> {
    PageData<WorkingProcedureDTO> page (Map<String, Object> params);

    WorkingProcedureDTO get(Long id);

    void save(WorkingProcedureDTO dto);

    void update(WorkingProcedureDTO dto);

    void delete(Long[] ids);

    boolean changeStatus(Long id);

    List<WorkingProcedureDTO> getWorkingProcedureByProductId(Long productId);

    List<WorkingProcedureDTO> list();
}