package com.cnbm.generator.code.excel;

import cn.afterturn.easypoi.excel.annotation.Excel;
import lombok.Data;

import java.time.LocalDateTime;
import java.math.BigDecimal;

import java.util.Date;

/**
 * 单位 表
 *
 * @author why
 * @since  2022-06-30
 */
@Data
public class UnitExcel {
    @Excel(name = "ID")
    private BigDecimal id;
    @Excel(name = "单位 名")
    private String name;
    @Excel(name = "单位 编码")
    private String code;
    @Excel(name = "单位类型，1 可计数，2 不可计数")
    private BigDecimal type;
    @Excel(name = "1 可用，0 不可用")
    private BigDecimal status;
    @Excel(name = "备注")
    private String remark;
    @Excel(name = "删除标志，是否有效:1 可用 0不可用")
    private BigDecimal valid;
    @Excel(name = "创建人")
    private BigDecimal creatorId;
    @Excel(name = "创建人姓名")
    private String creatorName;
    @Excel(name = "创建时间")
    private LocalDateTime createTime;
    @Excel(name = "更新人")
    private BigDecimal updaterId;
    @Excel(name = "更新人姓名")
    private String updaterName;
    @Excel(name = "更新时间")
    private LocalDateTime updateTime;
    @Excel(name = "版本号")
    private BigDecimal version;

}