package com.cnbm.generator.code.excel;

import cn.afterturn.easypoi.excel.annotation.Excel;
import lombok.Data;

import java.time.LocalDateTime;
import java.math.BigDecimal;

import java.util.Date;

/**
 * 系统用户
 *
 * @author why
 * @since  2022-08-23
 */
@Data
public class UserExcel {
    @Excel(name = "id")
    private Long id;
    @Excel(name = "用户名")
    private String username;
    @Excel(name = "密码")
    private String password;
    @Excel(name = "姓名")
    private String realName;
    @Excel(name = "头像")
    private String headUrl;
    @Excel(name = "性别   0：男   1：女    2：保密")
    private Integer gender;
    @Excel(name = "邮箱")
    private String email;
    @Excel(name = "手机号")
    private String mobile;
    @Excel(name = "部门ID")
    private Long deptId;
    @Excel(name = "超级管理员   0：否   1：是")
    private Integer superAdmin;
    @Excel(name = "状态  0：停用   1：正常")
    private Integer status;
    @Excel(name = "创建者")
    private Long creator;
    @Excel(name = "创建时间")
    private LocalDateTime createDate;
    @Excel(name = "更新者")
    private Long updater;
    @Excel(name = "更新时间")
    private LocalDateTime updateDate;

}