package com.cnbm.generator.code.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.cnbm.common.service.impl.CrudServiceImpl;
import com.cnbm.generator.code.dto.InspectionSheetDTO;
import com.cnbm.generator.code.mapper.InspectionSheetMapper;
import com.cnbm.generator.code.entity.InspectionSheet;
import com.cnbm.generator.code.service.IInspectionSheetService;
import org.apache.commons.lang3.StringUtils;
import org.springframework.stereotype.Service;

import java.util.Map;

/**
 * 检验单 表
 *
 * @author why
 * @since 2022-12-07
 */
@Service
public class InspectionSheetServiceImpl extends CrudServiceImpl<InspectionSheetMapper, InspectionSheet, InspectionSheetDTO> implements IInspectionSheetService {

    @Override
    public QueryWrapper<InspectionSheet> getWrapper(Map<String, Object> params){
        String id = (String)params.get("id");

        QueryWrapper<InspectionSheet> wrapper = new QueryWrapper<>();
        wrapper.eq(StringUtils.isNotBlank(id), "id", id);

        return wrapper;
    }


}