package com.cnbm.generator.code.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.cnbm.common.service.impl.CrudServiceImpl;
import com.cnbm.generator.code.dto.ProductFeaturesDTO;
import com.cnbm.generator.code.mapper.ProductFeaturesMapper;
import com.cnbm.generator.code.entity.ProductFeatures;
import com.cnbm.generator.code.service.IProductFeaturesService;
import org.apache.commons.lang3.StringUtils;
import org.springframework.stereotype.Service;

import java.util.Map;

/**
 * 产品特性 表
 *
 * @author why
 * @since 2022-08-23
 */
@Service
public class ProductFeaturesServiceImpl extends CrudServiceImpl<ProductFeaturesMapper, ProductFeatures, ProductFeaturesDTO> implements IProductFeaturesService {

    @Override
    public QueryWrapper<ProductFeatures> getWrapper(Map<String, Object> params){
        String id = (String)params.get("id");

        QueryWrapper<ProductFeatures> wrapper = new QueryWrapper<>();
        wrapper.eq(StringUtils.isNotBlank(id), "id", id);

        return wrapper;
    }


}