package com.cnbm.influx.controller;

import com.cnbm.influx.template.Event;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.time.Instant;
import java.util.List;

/**
 * @Desc: ""
 * @Author: caixiang
 * @DATE: 2022/12/9 15:53
 */
@Data
@ApiModel(value = "Events")
public class InfluxData {
    @ApiModelProperty("ID (transationId、argName、argValue、time 必填)")
    private List<Event> events;

    @ApiModelProperty("measurement(相当于mysql 中的table，一台工艺设备一个measurement)")
    private String measurement;

}
