package com.cnbm.influx.param;

import lombok.Data;
import org.hibernate.validator.constraints.Range;

/**
 * @Desc: ""
 * @Author: caixiang
 * @DATE: 2022/6/29 10:19
 */
@Data
public class PageInfo {
    @Range(min = 1, message = "页码必须大于等于1")
    private Integer current;

//    @NotNull(message = "每页显示条数不能为空")
    @Range(min = 1, max = 1000, message = "每页显示条数范围需在1-1000之间")
    private Integer size;

    public PageInfo(Integer current,Integer size){
        this.current = current;
        this.size = size;
    }
}
