package com.cnbm.influx.param;

import lombok.Data;

import javax.validation.constraints.NotNull;
import java.time.Instant;

/**
 * @Desc: "influxdb查询 时间范围"
 * @Author: caixiang
 * @DATE: 2022/6/29 11:14
 */
@Data
public class Range {
    @NotNull(message = "起始时间不能为空")
    private Instant begin;

    @NotNull(message = "终点时间不能为空")
    private Instant end;

    public Range(Instant begin,Instant end){
        this.begin = begin;
        this.end = end;
    }

//    public static void main(String[] args) {
//        Date date = new Date();
//        System.out.println(date.toInstant().toString());
//    }
}
