package com.cnbm.processInspection.controlCoefficientConstant;

/**
 * @Desc: " "x bar - R"  控制系数 "
 * @Author: caixiang
 * @DATE: 2022/6/30 10:44
 */
public class XBarRCoefficients {
    public static Double getA2(Integer sampleSize){
        if(sampleSize<=1){
            return null;
        }
        Double res = null;
        switch(sampleSize){
            //P92
            case 2:
                res = new Double(1.880);
                break;
            case 3:
                res = new Double(1.023);
                break;
            case 4:
                res = new Double(0.729);
                break;
            case 5:
                res = new Double(0.577);
                break;
            case 6:
                res = new Double(0.483);
                break;
            case 7:
                res = new Double(0.419);
                break;
            case 8:
                res = new Double(0.373);
                break;
            case 9:
                res = new Double(0.337);
                break;
            case 10:
                res = new Double(0.308);
                break;
            case 11:
                res = new Double(0.285);
                break;
            case 12:
                res = new Double(0.266);
                break;
            case 13:
                res = new Double(0.249);
                break;
            case 14:
                res = new Double(0.235);
                break;
            case 15:
                res = new Double(0.223);
                break;
            case 16:
                res = new Double(0.212);
                break;
            case 17:
                res = new Double(0.203);
                break;
            case 18:
                res = new Double(0.194);
                break;
            case 19:
                res = new Double(0.187);
                break;
            case 20:
                res = new Double(0.180);
                break;
            case 21:
                res = new Double(0.173);
                break;
            case 22:
                res = new Double(0.167);
                break;
            case 23:
                res = new Double(0.162);
                break;
            case 24:
                res = new Double(0.157);
                break;
            //大于等于25  都是用0.153
            default :
                res = new Double(0.153);
                break;
        }
        return res;
    }

    public static Double getD3(Integer sampleSize){
        if(sampleSize<=1){
            return null;
        }
        Double res = null;
        switch(sampleSize){
            //P92
            case 2:
                res = new Double(0);
                break;
            case 3:
                res = new Double(0);
                break;
            case 4:
                res = new Double(0);
                break;
            case 5:
                res = new Double(0);
                break;
            case 6:
                res = new Double(0);
                break;
            case 7:
                res = new Double(0.076);
                break;
            case 8:
                res = new Double(0.136);
                break;
            case 9:
                res = new Double(0.184);
                break;
            case 10:
                res = new Double(0.223);
                break;
            case 11:
                res = new Double(0.256);
                break;
            case 12:
                res = new Double(0.283);
                break;
            case 13:
                res = new Double(0.307);
                break;
            case 14:
                res = new Double(0.328);
                break;
            case 15:
                res = new Double(0.347);
                break;
            case 16:
                res = new Double(0.363);
                break;
            case 17:
                res = new Double(0.378);
                break;
            case 18:
                res = new Double(0.391);
                break;
            case 19:
                res = new Double(0.403);
                break;
            case 20:
                res = new Double(0.415);
                break;
            case 21:
                res = new Double(0.425);
                break;
            case 22:
                res = new Double(0.434);
                break;
            case 23:
                res = new Double(0.443);
                break;
            case 24:
                res = new Double(0.451);
                break;
            //大于等于25  都是用0.459
            default :
                res = new Double(0.459);
                break;
        }
        return res;
    }

        public static Double getD4(Integer sampleSize){
        if(sampleSize<=1){
            return null;
        }
        Double res = null;
        switch(sampleSize){
            //P92
            case 2:
                res = new Double(3.267);
                break;
            case 3:
                res = new Double(2.574);
                break;
            case 4:
                res = new Double(2.282);
                break;
            case 5:
                res = new Double(2.114);
                break;
            case 6:
                res = new Double(2.004);
                break;
            case 7:
                res = new Double(1.924);
                break;
            case 8:
                res = new Double(1.864);
                break;
            case 9:
                res = new Double(1.816);
                break;
            case 10:
                res = new Double(1.777);
                break;
            case 11:
                res = new Double(1.744);
                break;
            case 12:
                res = new Double(1.717);
                break;
            case 13:
                res = new Double(1.693);
                break;
            case 14:
                res = new Double(1.672);
                break;
            case 15:
                res = new Double(1.653);
                break;
            case 16:
                res = new Double(1.637);
                break;
            case 17:
                res = new Double(1.622);
                break;
            case 18:
                res = new Double(1.608);
                break;
            case 19:
                res = new Double(1.597);
                break;
            case 20:
                res = new Double(1.585);
                break;
            case 21:
                res = new Double(1.575);
                break;
            case 22:
                res = new Double(1.566);
                break;
            case 23:
                res = new Double(1.557);
                break;
            case 24:
                res = new Double(1.548);
                break;
            //大于等于25  都是用1.541
            default :
                res = new Double(1.541);
                break;
        }
        return res;
    }

}
