package com.cnbm.processInspection.controlCoefficientConstant;

/**
 * 均值-标准差 控制图  常数系数
 * @Desc: " "x bar - s"  控制系数 "
 * @Author: caixiang
 * @DATE: 2022/6/30 10:44
 */
public class XBarSCoefficients {
    public static Double getAS(Integer sampleSize){
        if(sampleSize<=1){
            return null;
        }
        Double res = null;
        switch(sampleSize){
            case 2:
                res = new Double(2.659);
                break;
            case 3:
                res = new Double(1.954);
                break;
            case 4:
                res = new Double(1.628);
                break;
            case 5:
                res = new Double(1.427);
                break;
            case 6:
                res = new Double(1.287);
                break;
            case 7:
                res = new Double(1.182);
                break;
            case 8:
                res = new Double(1.099);
                break;
            case 9:
                res = new Double(1.032);
                break;
            case 10:
                res = new Double(0.975);
                break;
            case 11:
                res = new Double(0.972);
                break;
            case 12:
                res = new Double(0.866);
                break;
            case 13:
                res = new Double(0.850);
                break;
            case 14:
                res = new Double(0.817);
                break;
            case 15:
                res = new Double(0.789);
                break;
            case 16:
                res = new Double(0.763);
                break;
            case 17:
                res = new Double(0.739);
                break;
            case 18:
                res = new Double(0.718);
                break;
            case 19:
                res = new Double(0.698);
                break;
            case 20:
                res = new Double(0.680);
                break;
            case 21:
                res = new Double(0.663);
                break;
            case 22:
                res = new Double(0.647);
                break;
            case 23:
                res = new Double(0.633);
                break;
            case 24:
                res = new Double(0.619);
                break;
            //大于等于25  都是用0.606
            default :
                res = new Double(0.606);
                break;
        }
        return res;
    }

    public static Double getBU(Integer sampleSize){
        if(sampleSize<=1){
            return null;
        }
        Double res = null;
        switch(sampleSize){
            case 2:
                res = new Double(3.267);
                break;
            case 3:
                res = new Double(2.568);
                break;
            case 4:
                res = new Double(2.266);
                break;
            case 5:
                res = new Double(2.089);
                break;
            case 6:
                res = new Double(1.970);
                break;
            case 7:
                res = new Double(1.882);
                break;
            case 8:
                res = new Double(1.815);
                break;
            case 9:
                res = new Double(1.761);
                break;
            case 10:
                res = new Double(1.716);
                break;
            case 11:
                res = new Double(1.679);
                break;
            case 12:
                res = new Double(1.646);
                break;
            case 13:
                res = new Double(1.618);
                break;
            case 14:
                res = new Double(1.594);
                break;
            case 15:
                res = new Double(1.572);
                break;
            case 16:
                res = new Double(1.552);
                break;
            case 17:
                res = new Double(1.534);
                break;
            case 18:
                res = new Double(1.518);
                break;
            case 19:
                res = new Double(1.503);
                break;
            case 20:
                res = new Double(1.490);
                break;
            case 21:
                res = new Double(1.477);
                break;
            case 22:
                res = new Double(1.466);
                break;
            case 23:
                res = new Double(1.455);
                break;
            case 24:
                res = new Double(1.445);
                break;
            //大于等于25  都是用1.435
            default :
                res = new Double(1.435);
                break;
        }
        return res;
    }

    public static Double getBL(Integer sampleSize){
        if(sampleSize<=1){
            return null;
        }
        Double res = null;
        switch(sampleSize){
            case 2:
                res = new Double(0);
                break;
            case 3:
                res = new Double(0);
                break;
            case 4:
                res = new Double(0);
                break;
            case 5:
                res = new Double(0);
                break;
            case 6:
                res = new Double(0.030);
                break;
            case 7:
                res = new Double(0.118);
                break;
            case 8:
                res = new Double(0.185);
                break;
            case 9:
                res = new Double(0.239);
                break;
            case 10:
                res = new Double(0.284);
                break;
            case 11:
                res = new Double(0.321);
                break;
            case 12:
                res = new Double(0.354);
                break;
            case 13:
                res = new Double(0.382);
                break;
            case 14:
                res = new Double(0.406);
                break;
            case 15:
                res = new Double(0.428);
                break;
            case 16:
                res = new Double(0.448);
                break;
            case 17:
                res = new Double(0.466);
                break;
            case 18:
                res = new Double(0.482);
                break;
            case 19:
                res = new Double(0.497);
                break;
            case 20:
                res = new Double(0.510);
                break;
            case 21:
                res = new Double(0.523);
                break;
            case 22:
                res = new Double(0.534);
                break;
            case 23:
                res = new Double(0.545);
                break;
            case 24:
                res = new Double(0.555);
                break;
            //大于等于25  都是用0.565
            default :
                res = new Double(0.565);
                break;
        }
        return res;
    }
}
