package com.cnbm.processInspection.dto;

import com.cnbm.common.spc.math.StandardDiviation;
import com.cnbm.processInspection.graphAnalyzed.forMeterage.xmr.XMRGraphEntity;
import com.cnbm.qualityPlanning.entity.ControlLimit;
import com.cnbm.qualityPlanning.entity.NPPoint;
import com.cnbm.qualityPlanning.entity.ProcessCapability;
import com.cnbm.qualityPlanning.entity.SpecificationLimit;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.List;

/**
 * @Desc: ""
 * @Author: caixiang
 * @DATE: 2022/7/22 14:18
 */
@Data
@ApiModel(value = "NP控制图 结果类")
public class NPGraphData {
    @ApiModelProperty(value = "NP控制图list数据")
    private List<NPPoint> list;
//    @ApiModelProperty(value = "NP控制图 规格线")
//    private SpecificationLimit specificationLimit;
    @ApiModelProperty(value = "NP控制图 参数名")
    private String argName;

    public NPGraphData(List<NPPoint> list, String argName) {
        this.list = list;
//        this.specificationLimit = specificationLimit;
        this.argName = argName;
    }
}
