package com.cnbm.processInspection.mapper;

import com.cnbm.basic.dto.ProductFeaturesDTO;
import com.cnbm.common.dao.BaseDao;
import com.cnbm.processInspection.dto.InspectionSheetDTO;
import com.cnbm.processInspection.entity.InspectionSheet;
import org.apache.ibatis.annotations.Mapper;

import java.util.List;
import java.util.Map;

/**
 * 检验单 表
 *
 * @author why
 * @since 2022-08-17
 */
@Mapper
public interface InspectionSheetMapper extends BaseDao<InspectionSheet> {
	List<InspectionSheetDTO> list(Map<String, Object> params);
//	Integer getNumberOfSamples(Map<String, Object> params);
	List<ProductFeaturesDTO> getInspectionSheetFeaturesList(Map<String, Object> params);
}