package com.cnbm.qualityPlanning.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * <p>
 * 判读方案 表
 * </p>
 *
 * @author why
 * @since 2022-08-16
 */
@Data
@TableName("my_interpretation_scheme")
@ApiModel(value = "MyInterpretationScheme对象", description = "自定义判读方案 表")
public class MyInterpretationScheme implements Serializable {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty("ID")
    private Long id;

    @ApiModelProperty("判读方案编号")
    private Integer code;

    @ApiModelProperty("自定义判读方案名")
    private String name;

    @ApiModelProperty("备注")
    private String remark;

    @ApiModelProperty("删除标志，是否有效:1 可用 0不可用")
    private Integer valid;

    @ApiModelProperty("创建人")
    private Long creatorId;

    @ApiModelProperty("创建人姓名")
    private String creatorName;

    @ApiModelProperty("创建时间")
    private LocalDateTime createTime;

    @ApiModelProperty("更新人")
    private Long updaterId;

    @ApiModelProperty("更新人姓名")
    private String updaterName;

    @ApiModelProperty("更新时间")
    private LocalDateTime updateTime;

    @ApiModelProperty("版本号")
    private Integer version;


}
