package com.cnbm.qualityPlanning.entity;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.List;

/**
 * @Desc: ""
 * @Author: caixiang
 * @DATE: 2022/7/12 15:17
 */
@Data
@ApiModel(value = "工序能力")
public class ProcessCapability {
    //工序能力指数CP
    @ApiModelProperty(value = "工序能力指数CP")
    private Double CP;
    //实际工序能力指数CPK
    @ApiModelProperty(value = "实际工序能力指数CPK")
    private Double CPK;
    //上侧规范 工序能力指数CPU
    @ApiModelProperty(value = "上侧规范 工序能力指数CPU")
    private Double CPU;
    //下侧规范 工序能力指数CPL
    @ApiModelProperty(value = "下侧规范 工序能力指数CPL")
    private Double CPL;

    @ApiModelProperty(value = "工序能力报警")
    private List<String> warming;

    public ProcessCapability(Double CP, Double CPK, Double CPU, Double CPL,List<String> warming) {
        this.CP = CP;
        this.CPK = CPK;
        this.CPU = CPU;
        this.CPL = CPL;
        this.warming = warming;
    }
}
