package com.cnbm.qualityPlanning.entity;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

/**
 * @Desc: ""
 * @Author: caixiang
 * @DATE: 2022/7/12 15:19
 */
@Data
@ApiModel(value = "规格限")
public class SpecificationLimit {
    //规格上限
    @ApiModelProperty(value = "规格上限")
    private Float USL;
    //规格中心线
    @ApiModelProperty(value = "规格中心限")
    private Float SL;
    //规格下限
    @ApiModelProperty(value = "规格下限")
    private Float LSL;

    public SpecificationLimit(Float USL, Float SL, Float LSL) {
        this.USL = USL;
        this.SL = SL;
        this.LSL = LSL;
    }
}
