package com.cnbm.qualityPlanning.excel;

import cn.afterturn.easypoi.excel.annotation.Excel;
import lombok.Data;

import java.time.LocalDateTime;
import java.math.BigDecimal;

import java.util.Date;

/**
 * 判读方案 表
 *
 * @author why
 * @since  2022-09-20
 */
@Data
public class InterpretationSchemeExcel {
    @Excel(name = "ID")
    private Long id;
    @Excel(name = "判读方案编号（手动输入），一旦add了，就不允许update这个字段")
    private Integer code;
    @Excel(name = "判读方案规则号（1-10）")
    private Integer ruleNum;
    @Excel(name = "判读方案规则,(eg: 规则五:连续x点中有x点落在中心线同侧两倍标准差以外)")
    private String ruleKey;
    @Excel(name = "判读方案vaule1,(3)")
    private Integer ruleValue1;
    @Excel(name = "判读方案vaule2,(2)")
    private Integer ruleValue2;
    @Excel(name = "自定义判读方案id")
    private Long myInterpretationSchemeId;
    @Excel(name = "'1 = activate, 0 = inactivate '")
    private Integer flag;
    @Excel(name = "备注")
    private String remark;
    @Excel(name = "删除标志，是否有效:1 可用 0不可用")
    private Integer valid;
    @Excel(name = "创建人")
    private Long creatorId;
    @Excel(name = "创建人姓名")
    private String creatorName;
    @Excel(name = "创建时间")
    private LocalDateTime createTime;
    @Excel(name = "更新人")
    private Long updaterId;
    @Excel(name = "更新人姓名")
    private String updaterName;
    @Excel(name = "更新时间")
    private LocalDateTime updateTime;
    @Excel(name = "版本号")
    private Integer version;

}