package com.cnbm.qualityPlanning.mapper;

import com.cnbm.common.dao.BaseDao;
import com.cnbm.qualityPlanning.dto.InterpretationSchemeDTO;
import com.cnbm.qualityPlanning.entity.InterpretationScheme;
import org.apache.ibatis.annotations.Mapper;

import java.util.List;
import java.util.Map;

/**
 * 判读方案 表
 *
 * @author why
 * @since 2022-08-15
 */
@Mapper
public interface InterpretationSchemeMapper extends BaseDao<InterpretationScheme> {

    List<InterpretationSchemeDTO> list();

    List<InterpretationSchemeDTO> listByMyInterpretationSchemeId(Map<String, Object> params);

    void batchInsert(Long myInterpretationSchemeId);

}