package com.cnbm.basic.excel;

import cn.afterturn.easypoi.excel.annotation.Excel;
import lombok.Data;

import java.time.LocalDateTime;

/**
 * 产品类型 表
 *
 * @author why
 * @since  2022-06-30
 */
@Data
public class ProductTypeExcel {
    @Excel(name = "ID")
    private Long id;
    @Excel(name = "产品类型 名")
    private String name;
    @Excel(name = "产品类型 编码")
    private String code;
    @Excel(name = "描述")
    private String descs;
    @Excel(name = "1 可用，0 不可用")
    private Integer status;
    @Excel(name = "备注")
    private String remark;
    @Excel(name = "删除标志，是否有效:1 可用 0不可用")
    private Integer valid;
    @Excel(name = "创建人")
    private Long creatorId;
    @Excel(name = "创建人姓名")
    private String creatorName;
    @Excel(name = "创建时间")
    private LocalDateTime createTime;
    @Excel(name = "更新人")
    private Long updaterId;
    @Excel(name = "更新人姓名")
    private String updaterName;
    @Excel(name = "更新时间")
    private LocalDateTime updateTime;
    @Excel(name = "版本号")
    private Integer version;

}