package com.cnbm.basic.excel;

import cn.afterturn.easypoi.excel.annotation.Excel;
import lombok.Data;

import java.time.LocalDateTime;

/**
 * 工序 表
 *
 * @author why
 * @since  2022-07-15
 */
@Data
public class ProductWorkingprocedureRelationExcel {
    @Excel(name = "ID")
    private Long id;
    @Excel(name = "产品id,关联product表")
    private Long productId;
    @Excel(name = "工序id,关联 working_procedure 表")
    private Long workingProcedureId;
    @Excel(name = "顺序，工序是有先后顺序的。")
    private Integer sequence;
    @Excel(name = "1 可用，0 不可用")
    private Integer status;
    @Excel(name = "node.shape")
    private String shape;
    @Excel(name = "node.x")
    private Integer x;
    @Excel(name = "node.y")
    private Integer y;
    @Excel(name = "node.width")
    private Integer width;
    @Excel(name = "node.width")
    private Integer height;
    @Excel(name = "node.lable")
    private String lable;
    @Excel(name = "字体颜色")
    private String fontcolor;
    @Excel(name = "背景颜色")
    private String backcolor;
    @Excel(name = "备注")
    private String remark;
    @Excel(name = "删除标志，是否有效:1 可用 0不可用")
    private Integer valid;
    @Excel(name = "创建人")
    private Long creatorId;
    @Excel(name = "创建人姓名")
    private String creatorName;
    @Excel(name = "创建时间")
    private LocalDateTime createTime;
    @Excel(name = "更新人")
    private Long updaterId;
    @Excel(name = "更新人姓名")
    private String updaterName;
    @Excel(name = "更新时间")
    private LocalDateTime updateTime;
    @Excel(name = "版本号")
    private Integer version;

}