package com.cnbm.basic.mapper;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.cnbm.basic.dto.MachineDTO;
import com.cnbm.common.dao.BaseDao;
import com.cnbm.basic.entity.Machine;
import com.cnbm.common.page.PageData;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;
import java.util.Map;

/**
 * 机台表
 *
 * @author why
 * @since 2022-07-15
 */
@Mapper
public interface MachineMapper extends BaseDao<Machine> {
	PageData<MachineDTO> page(Map<String, Object> params);

	List<MachineDTO> list(Map<String, Object> params);
}