package com.cnbm.basic.service;

import com.cnbm.common.page.PageData;
import com.cnbm.common.service.CrudService;
import com.cnbm.basic.dto.FactoryDTO;
import com.cnbm.basic.entity.Factory;

import java.util.List;
import java.util.Map;

/**
 * 工厂 表
 *
 * @author why
 * @since  2022-07-13
 */
public interface IFactoryService extends CrudService<Factory, FactoryDTO> {
    PageData<FactoryDTO> page (Map<String, Object> params);

    FactoryDTO get(Long id);

    void save(FactoryDTO dto);

    void update(FactoryDTO dto);

    void delete(Long[] ids);

    List<FactoryDTO> list();

    boolean changeStatus(Long id);
}