package com.cnbm.basic.service;

import com.cnbm.common.page.PageData;
import com.cnbm.common.service.CrudService;
import com.cnbm.basic.dto.MeasureToolDTO;
import com.cnbm.basic.entity.MeasureTool;

import java.util.List;
import java.util.Map;

/**
 * 量具表
 *
 * @author why
 * @since  2022-07-13
 */
public interface IMeasureToolService extends CrudService<MeasureTool, MeasureToolDTO> {
    PageData<MeasureToolDTO> page (Map<String, Object> params);

    MeasureToolDTO get(Long id);

    void save(MeasureToolDTO dto);

    void update(MeasureToolDTO dto);

    void delete(Long[] ids);

    boolean changeStatus(Long id);

    List<MeasureToolDTO> list();
}