package com.cnbm.basic.service;

import com.cnbm.basic.dto.ProductWorkingprocedureRelationDTO;
import com.cnbm.common.page.PageData;
import com.cnbm.common.service.CrudService;
import com.cnbm.basic.dto.ProductFactoryRelationDTO;
import com.cnbm.basic.entity.ProductFactoryRelation;

import java.util.Map;

/**
 * 产品-工厂 关系表
 *
 * @author why
 * @since  2022-07-27
 */
public interface IProductFactoryRelationService extends CrudService<ProductFactoryRelation, ProductFactoryRelationDTO> {

    PageData<ProductFactoryRelationDTO> page (Map<String, Object> params);

    ProductFactoryRelationDTO get(Long id);

    void save(ProductFactoryRelationDTO dto);

    void update(ProductFactoryRelationDTO dto);

    void delete(Long[] ids);

    void batchInsertFactory(ProductFactoryRelationDTO[] lists);

}