package com.cnbm.basic.service;

import com.cnbm.common.page.PageData;
import com.cnbm.common.service.CrudService;
import com.cnbm.basic.dto.ProductFeaturesHisDTO;
import com.cnbm.basic.entity.ProductFeaturesHis;

import java.util.Map;

/**
 * 产品特性 历史表
 *
 * @author why
 * @since  2022-07-15
 */
public interface IProductFeaturesHisService extends CrudService<ProductFeaturesHis, ProductFeaturesHisDTO> {
    PageData<ProductFeaturesHisDTO> page (Map<String, Object> params);

    ProductFeaturesHisDTO get(Long id);

    void save(ProductFeaturesHisDTO dto);

    void update(ProductFeaturesHisDTO dto);

    void delete(Long[] ids);
}