package com.cnbm.basic.service;

import com.cnbm.common.page.PageData;
import com.cnbm.common.service.CrudService;
import com.cnbm.basic.dto.ProductTypeDTO;
import com.cnbm.basic.entity.ProductType;

import java.util.List;
import java.util.Map;

/**
 * 产品类型 表
 *
 * @author why
 * @since  2022-06-30
 */
public interface IProductTypeService extends CrudService<ProductType, ProductTypeDTO> {
    PageData<ProductTypeDTO> page (Map<String, Object> params);

    ProductTypeDTO get(Long id);

    void save(ProductTypeDTO dto);

    void update(ProductTypeDTO dto);

    void delete(Long[] ids);

    List<ProductTypeDTO> list();

    boolean changeStatus(Long id);
}