package com.cnbm.basic.service;

import com.cnbm.basic.dto.SequenceDTO;
import com.cnbm.basic.dto.WorkingProcedureDTO;
import com.cnbm.common.page.PageData;
import com.cnbm.common.service.CrudService;
import com.cnbm.basic.dto.ProductWorkingprocedureRelationDTO;
import com.cnbm.basic.entity.ProductWorkingprocedureRelation;

import java.util.List;
import java.util.Map;

/**
 * 工序 表
 *
 * @author why
 * @since  2022-07-15
 */
public interface IProductWorkingprocedureRelationService extends CrudService<ProductWorkingprocedureRelation, ProductWorkingprocedureRelationDTO> {
    PageData<ProductWorkingprocedureRelationDTO> page (Map<String, Object> params);

    ProductWorkingprocedureRelationDTO get(Long id);

    void save(ProductWorkingprocedureRelationDTO dto);

    void update(ProductWorkingprocedureRelationDTO dto);

    void delete(Long[] ids);

    List<ProductWorkingprocedureRelationDTO> getWorkingprocedureByProductId(Long productId);

    void batchInsertWorkingprocedure(ProductWorkingprocedureRelationDTO[] lists);

    void sequenceUp(SequenceDTO sequenceDTO);

    void sequenceDown(SequenceDTO sequenceDTO);
}