package com.cnbm.basic.service;

import com.cnbm.common.page.PageData;
import com.cnbm.common.service.CrudService;
import com.cnbm.basic.dto.ShiftDTO;
import com.cnbm.basic.entity.Shift;

import java.util.List;
import java.util.Map;

/**
 * 班次 表
 *
 * @author why
 * @since  2022-07-13
 */
public interface IShiftService extends CrudService<Shift, ShiftDTO> {
    PageData<ShiftDTO> page (Map<String, Object> params);

    ShiftDTO get(Long id);

    void save(ShiftDTO dto);

    void update(ShiftDTO dto);

    void delete(Long[] ids);

    List<ShiftDTO> list();
}