package com.cnbm.basic.service;

import com.cnbm.common.page.PageData;
import com.cnbm.common.service.CrudService;
import com.cnbm.basic.dto.WorkingProcedureTypeDTO;
import com.cnbm.basic.entity.WorkingProcedureType;

import java.util.Map;

/**
 * 工序类型表 表
 *
 * @author why
 * @since  2022-07-15
 */
public interface IWorkingProcedureTypeService extends CrudService<WorkingProcedureType, WorkingProcedureTypeDTO> {
    PageData<WorkingProcedureTypeDTO> page (Map<String, Object> params);

    WorkingProcedureTypeDTO get(Long id);

    void save(WorkingProcedureTypeDTO dto);

    void update(WorkingProcedureTypeDTO dto);

    void delete(Long[] ids);

    boolean changeStatus(Long id);
}