package com.cnbm.common.spc.math;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

/**
 * @Desc: ""
 * @Author: caixiang
 * @DATE: 2022/7/25 15:23
 */
@Data
@ApiModel(value = "标准差结果类")
public class StandardDiviation {
    //组内标准差
    @ApiModelProperty(value = "组内标准差")
    private Double normal;
    //总体标准差
    @ApiModelProperty(value = "总体标准差")
    private Double totality;

    public StandardDiviation(Double normal, Double totality) {
        this.normal = normal;
        this.totality = totality;
    }
}
