package com.cnbm.generator.code.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.cnbm.common.service.impl.CrudServiceImpl;
import com.cnbm.generator.code.dto.UnitDTO;
import com.cnbm.generator.code.mapper.UnitMapper;
import com.cnbm.generator.code.entity.Unit;
import com.cnbm.generator.code.service.IUnitService;
import org.apache.commons.lang3.StringUtils;
import org.springframework.stereotype.Service;

import java.util.Map;

/**
 * 单位 表
 *
 * @author why
 * @since 2022-06-30
 */
@Service
public class UnitServiceImpl extends CrudServiceImpl<UnitMapper, Unit, UnitDTO> implements IUnitService {

    @Override
    public QueryWrapper<Unit> getWrapper(Map<String, Object> params){
        String id = (String)params.get("id");

        QueryWrapper<Unit> wrapper = new QueryWrapper<>();
        wrapper.eq(StringUtils.isNotBlank(id), "id", id);

        return wrapper;
    }


}