package com.cnbm.influx.param;

import lombok.Data;

import javax.validation.constraints.NotEmpty;
import javax.validation.constraints.NotNull;
import java.io.Serializable;

/**
 * @Desc: ""
 * @Author: caixiang
 * @DATE: 2022/6/29 10:18
 */
@Data
public class BaseParam implements Serializable {
    //page 信息可选
    private PageInfo pageInfo;

    @NotEmpty(message = "measurement 不能为空")
    private String measurement;

    @NotNull(message = "查询时间段不能为空")
    private Range range;


}
