package com.cnbm.influx.template;

import com.influxdb.annotations.Column;
import com.influxdb.annotations.Measurement;
import lombok.Data;

import javax.validation.constraints.NotNull;
import java.time.Instant;

/**
 * @Desc: "常规计量值 - entity"
 * @Author: caixiang
 * @DATE: 2022/6/25 11:13
 */
@Data
public class Sample {

    private String inspectionSheetId;

    private Instant sampleTime;

    private String workingProcedureName;

    private String sampleNumber;

    private String argName;

    private String argValue;

}
