package com.cnbm.processInspection.dto;

import com.cnbm.qualityPlanning.entity.CPoint;
import com.cnbm.qualityPlanning.entity.PPoint;
import com.cnbm.qualityPlanning.entity.SpecificationLimit;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.List;

/**
 * @Desc: ""
 * @Author: caixiang
 * @DATE: 2022/7/22 14:18
 */
@Data
@ApiModel(value = "C控制图 结果类")
public class CGraphData {
    @ApiModelProperty(value = "C控制图list数据")
    private List<CPoint> list;
    //计数类参数，不需要显示规格线
//    @ApiModelProperty(value = "C控制图 规格线")
//    private SpecificationLimit specificationLimit;
    @ApiModelProperty(value = "C控制图 参数名")
    private String argName;

    public CGraphData(List<CPoint> list, String argName) {
        this.list = list;
//        this.specificationLimit = specificationLimit;
        this.argName = argName;
    }
}
