package com.cnbm.processInspection.dto;

import com.cnbm.influx.template.Event;
import com.cnbm.influx.template.SampleParam;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.time.Instant;
import java.util.List;

/**
 * 检验样本 表
 *
 * @author yanyang
 * @since  2022-11-24
 */
@Data
@ApiModel(value = "检验样本 DTO3对象")
public class InspectionSampleDTO3 implements Serializable {

    @ApiModelProperty(value = "检验单id")
    private String inspectionSheetId;

    @ApiModelProperty(value = "取样时间")
    private Instant sampleTime;

    @ApiModelProperty(value = "批次号")
    private String batchNum;

    @ApiModelProperty(value = "样本号")
    private String sampleNumber;

    @ApiModelProperty(value = "检验参数")
    private List<SampleParam> sampleParamList;
}
