package com.cnbm.processInspection.graphAnalyzed.forMeterage.xmr;



import com.cnbm.qualityPlanning.entity.XMRPoint;
import com.cnbm.qualityPlanning.entity.XbarRPoint;

import java.util.List;

/**
 * @Desc: "xbar-R 结果类"
 * @Author: caixiang
 * @DATE: 2022/7/21 16:26
 */
public class XMRGraphEntity {
    private List<XMRPoint> list;
    private Double xbar;
    private Double rsbar;

    public XMRGraphEntity(List<XMRPoint> list, Double xbar, Double rsbar){
        this.list = list;
        this.rsbar = rsbar;

        this.xbar = xbar;
    }

    public List<XMRPoint> getList() {
        return list;
    }

    public void setList(List<XMRPoint> list) {
        this.list = list;
    }

    public Double getXbar() {
        return xbar;
    }

    public void setXbar(Double xbar) {
        this.xbar = xbar;
    }

    public Double getRsbar() {
        return rsbar;
    }

    public void setRsbar(Double rsbar) {
        this.rsbar = rsbar;
    }
}
