package com.cnbm.qualityPlanning.common;


import com.cnbm.qualityPlanning.entity.*;
import io.swagger.models.auth.In;


import java.util.*;

/**
 * @Desc: "检测参数统计受控  检验类"
 * @Author: caixiang
 * todo ： ① 开头第一组，和最后一组 是否漏掉 问题；② 中间情况 时候把最后一个元素漏掉。
 * @DATE: 2022/7/11 15:27
 */
public class StatisticalControlledTest {
    private static final Integer rule1Number = 1;
    private static final Integer rule2Number = 2;
    private static final Integer rule3Number = 3;
    private static final Integer rule4Number = 4;
    private static final Integer rule5Number = 5;
    private static final Integer rule6Number = 6;
    private static final Integer rule7Number = 7;
    private static final Integer rule8Number = 8;
    private static final Integer rule9Number = 9;
    private static final Integer rule10Number = 10;

    public static List<Point> createData(){
        Point point = new Point(1,new Double(0.7));
        Point point2 = new Point(2,new Double(0.7));
        Point point3 = new Point(3,new Double(3.7));
        Point point4 = new Point(4,new Double(0.7));
        Point point5 = new Point(5,new Double(0.7));
        Point point6 = new Point(6,new Double(3.7));   //3
        Point point7 = new Point(7,new Double(3.7));          //3
        Point point8 = new Point(8,new Double(3.7));   //3    //3
        Point point9 = new Point(9,new Double(3.7));
        Point point10 = new Point(10,new Double(3.7));
        Point point11 = new Point(11,new Double(3.7));
        Point point12 = new Point(12,new Double(3.7));
        Point point13 = new Point(13,new Double(3.7));
        Point point14 = new Point(14,new Double(3.7));
        Point point15 = new Point(15,new Double(3.7));
        Point point16 = new Point(16,new Double(3.7));
        Point point17 = new Point(17,new Double(3.7));
        Point point18 = new Point(18,new Double(3.7));
        Point point19 = new Point(19,new Double(3.7));
        Point point20 = new Point(20,new Double(3.7));

        List<Point> list = new ArrayList<>();
        list.add(point);
        list.add(point2);
        list.add(point3);
        list.add(point4);
        list.add(point5);
        list.add(point6);
        list.add(point7);
        list.add(point8);
        list.add(point9);
        list.add(point10);
        list.add(point11);
        list.add(point12);
        return list;
    }
    public static List<Point> createData2(){
        XbarSPoint point = new XbarSPoint(1, new Double(2.5));
        point.setS(new Double(2.5));
        XbarSPoint point2 = new XbarSPoint(2, new Double(2.5));
        point2.setS(new Double(2.5));
        XbarSPoint point3 = new XbarSPoint(3, new Double(2.5));
        point3.setS(new Double(2.5));
        XbarSPoint point4 = new XbarSPoint(4, new Double(2.5));
        point4.setS(new Double(2.5));
        XbarSPoint point5 = new XbarSPoint(5, new Double(2.5));
        point5.setS(new Double(2.5));
        XbarSPoint point6 = new XbarSPoint(6, new Double(2.5));
        point6.setS(new Double(2.5));
        XbarSPoint point7 = new XbarSPoint(7, new Double(2.5));
        point7.setS(new Double(2.5));
        XbarSPoint point8 = new XbarSPoint(8, new Double(2));
        point8.setS(new Double(2));
        XbarSPoint point9 = new XbarSPoint(9, new Double(2.5));
        point9.setS(new Double(2.5));
        XbarSPoint point10 = new XbarSPoint(10, new Double(2.5));
        point10.setS(new Double(2.5));
        XbarSPoint point11 = new XbarSPoint(11, new Double(2.5));
        point11.setS(new Double(2.5));
        XbarSPoint point12 = new XbarSPoint(12, new Double(2.5));
        point12.setS(new Double(2.5));
        XbarSPoint point13 = new XbarSPoint(13,new Double(2.5));
        point13.setS(new Double(2.5));
        XbarSPoint point14 = new XbarSPoint(14,new Double(2.5));
        point14.setS(new Double(2.5));
        XbarSPoint point15 = new XbarSPoint(15,new Double(2.5));
        point15.setS(new Double(2.5));
        XbarSPoint point16 = new XbarSPoint(16,new Double(2));
        point16.setS(new Double(2));
        XbarSPoint point17 = new XbarSPoint(17,new Double(2.5));
        point17.setS(new Double(2.5));
        XbarSPoint point18 = new XbarSPoint(18,new Double(2.5));
        point18.setS(new Double(2.5));
        XbarSPoint point19 = new XbarSPoint(19,new Double(2.5));
        point19.setS(new Double(2.5));
        XbarSPoint point20 = new XbarSPoint(20,new Double(2.5));
        point20.setS(new Double(2.5));
        XbarSPoint point21 = new XbarSPoint(21,new Double(2.5));
        point21.setS(new Double(2.5));
        XbarSPoint point22 = new XbarSPoint(22,new Double(2.5));
        point22.setS(new Double(2.5));
        XbarSPoint point23 = new XbarSPoint(23,new Double(2.5));
        point23.setS(new Double(2.5));
        List<Point> list = new ArrayList<>();
        list.add(point);
        list.add(point2);
        list.add(point3);
        list.add(point4);
        list.add(point5);
        list.add(point6);
        list.add(point7);
        list.add(point8);
        list.add(point9);
        list.add(point10);
        list.add(point11);
        list.add(point12);
        list.add(point13);
        list.add(point14);
        list.add(point15);
        list.add(point16);
        list.add(point17);
        list.add(point18);
        list.add(point19);
        list.add(point20);
        list.add(point21);
        list.add(point22);
        list.add(point23);
        return list;
    }
    public static List<XbarSPoint> createData3(){
        XbarSPoint point = new XbarSPoint(1, new Double(2.5));
        point.setS(new Double(0.5));
        point.setXbar(new Double(2.5));
        XbarSPoint point2 = new XbarSPoint(2, new Double(2.5));
        point2.setS(new Double(0.5));
        point2.setXbar(new Double(2.5));
        XbarSPoint point3 = new XbarSPoint(3, new Double(2.5));
        point3.setS(new Double(0.5));
        point3.setXbar(new Double(2.5));
        XbarSPoint point4 = new XbarSPoint(4, new Double(2.5));
        point4.setS(new Double(0.5));
        point4.setXbar(new Double(2.5));
        XbarSPoint point5 = new XbarSPoint(5, new Double(2.5));
        point5.setS(new Double(0.5));
        point5.setXbar(new Double(2.5));
        XbarSPoint point6 = new XbarSPoint(6, new Double(2.5));
        point6.setS(new Double(5));
        point6.setXbar(new Double(5));
        XbarSPoint point7 = new XbarSPoint(7, new Double(2.5));
        point7.setS(new Double(20.5));
        point7.setXbar(new Double(20.5));
        XbarSPoint point8 = new XbarSPoint(8, new Double(2));
        point8.setS(new Double(2));
        point8.setXbar(new Double(2.5));
        XbarSPoint point9 = new XbarSPoint(9, new Double(2.5));
        point9.setS(new Double(2.5));
        point9.setXbar(new Double(2.5));
        XbarSPoint point10 = new XbarSPoint(10, new Double(2.5));
        point10.setS(new Double(2.5));
        point10.setXbar(new Double(2.5));
        XbarSPoint point11 = new XbarSPoint(11, new Double(2.5));
        point11.setS(new Double(2.5));
        point11.setXbar(new Double(2.5));
        XbarSPoint point12 = new XbarSPoint(12, new Double(2.5));
        point12.setS(new Double(2.5));
        point12.setXbar(new Double(2.5));
        XbarSPoint point13 = new XbarSPoint(13,new Double(2.5));
        point13.setS(new Double(30.5));
        point13.setXbar(new Double(30.5));
        XbarSPoint point14 = new XbarSPoint(14,new Double(2.5));
        point14.setS(new Double(2.5));
        point14.setXbar(new Double(2.5));
        XbarSPoint point15 = new XbarSPoint(15,new Double(2.5));
        point15.setS(new Double(7));
        point15.setXbar(new Double(2.5));
        XbarSPoint point16 = new XbarSPoint(16,new Double(2));
        point16.setS(new Double(7));
        point16.setXbar(new Double(2.5));
        XbarSPoint point17 = new XbarSPoint(17,new Double(2.5));
        point17.setS(new Double(7));
        point17.setXbar(new Double(2.5));
        XbarSPoint point18 = new XbarSPoint(18,new Double(2.5));
        point18.setS(new Double(7));
        point18.setXbar(new Double(2.5));
        XbarSPoint point19 = new XbarSPoint(19,new Double(2.5));
        point19.setS(new Double(7));
        point19.setXbar(new Double(2.5));
        XbarSPoint point20 = new XbarSPoint(20,new Double(2.5));
        point20.setS(new Double(7));
        point20.setXbar(new Double(2.5));
        XbarSPoint point21 = new XbarSPoint(21,new Double(2.5));
        point21.setS(new Double(7));
        point21.setXbar(new Double(2.5));
        XbarSPoint point22 = new XbarSPoint(22,new Double(2.5));
        point22.setS(new Double(7));
        point22.setXbar(new Double(2.5));
        XbarSPoint point23 = new XbarSPoint(23,new Double(2.5));
        point23.setS(new Double(7));
        point23.setXbar(new Double(2.5));
        List<XbarSPoint> list = new ArrayList<>();
        list.add(point);
        list.add(point2);
        list.add(point3);
        list.add(point4);
        list.add(point5);
        list.add(point6);
        list.add(point7);
        list.add(point8);
        list.add(point9);
        list.add(point10);
        list.add(point11);
        list.add(point12);
        list.add(point13);
        list.add(point14);
        list.add(point15);
        list.add(point16);
        list.add(point17);
        list.add(point18);
        list.add(point19);
        list.add(point20);
        list.add(point21);
        list.add(point22);
        list.add(point23);
        return list;
    }

    public static void main(String[] args) {
//        List<Point> list = createData();
        List<Point> list = createData2();

        ControlLimit controlLimit = new ControlLimit(new Double(12),new Double(3),new Double(1));
        System.out.println("controlLimit : "+controlLimit.toString());
        //
//        //TEST FOR RULE1
//        Boolean aBoolean1 = rule1(list, controlLimit);
//
        //TEST FOR RULE2
//        Boolean aBoolean2 = rule2(list, controlLimit, 5);
//        System.out.println();
//
//
//        //TEST FOR RULE3
//        Boolean aBoolean3 = rule3(list, 3);
//        System.out.println();
//
//
//        //TEST FOR RULE4
//        Boolean aBoolean4 = rule4(list, 6);
//        System.out.println();

//        //TEST FOR RULE5
//        Boolean aBoolean5 = rule5(list, controlLimit, 3,2);
//        System.out.println();

//        //TEST FOR RULE6
        // >6  或者 <2.3
//        Boolean aBoolean6 = rule6(list, controlLimit, 5,4);
//        System.out.println();

        //TEST FOR RULE7
        //LC0 = 1.6666  ;; UC1 = 5
        // //>2.33    <3
//        Boolean aBoolean7 = rule7(list, controlLimit,7);
//        System.out.println();

        //TEST FOR RULE8
//        Boolean aBoolean8 = rule8(list, controlLimit,8);
//        System.out.println();

//        int[] array={1,2,3,4,5,6};
//        int[] ret=new int[3];
//        System.arraycopy(array,0,ret,0,3);
//        System.out.println(Arrays.toString(ret));
    }

    /**
     * status : ok
     * name : 规则1
     * desc : 控制图上有 1 个点位于三倍标准差以外(对中心线来说)（母体的 $\sigma$ ）
     * 注意： 如果存在满足rule1的点，会在原数组 Point.unsatisfiedRules 里标注出来。
     * return :
     *      存在满足rule1的点  =>   true
     *      不存在满足rule1的点  =>   false
     * */
    public static Boolean rule1(List<Point> data, ControlLimit controlLimit){
        Boolean flag = false;
        for(Point i:data){
            if(i.getValueForInterpretation() > controlLimit.getUCL() || i.getValueForInterpretation() < controlLimit.getLCL()){
                i.getUnsatisfiedRules().add(rule1Number);
                flag = true;
            }
        }
        return flag;
    }

    private static void markUnsatisfiedRulesByKeys(List<Point> data,List<Integer> keys,Integer ruleNumber){
        for (Integer key:keys){
            data.get(key).getUnsatisfiedRules().add(ruleNumber);
        }
    }

    /**
     * status : ok
     * name : 规则2
     * desc : 连续 n 点落在中心线的同一侧 (默认：9)
     * 注意： 如果存在满足rule2的点，会在原数组 Point.unsatisfiedRules 里标注出来。
     * return :
     *      存在满足rule2的点  =>   true
     *      不存在满足rule2的点  =>   false
     * */
    public static Boolean rule2(List<Point> data, ControlLimit controlLimit,Integer n){
        Boolean result = false;

        List<Point> upList = new ArrayList<>();
        List<Point> downList = new ArrayList<>();
        for(Point i:data){
            if(i.getValueForInterpretation() > controlLimit.getCL()){
                upList.add(i);
            }else if(i.getValueForInterpretation() < controlLimit.getCL()){
                downList.add(i);
            }
        }

        //上侧的情况
        Integer upi = 0;
        Integer uptime = 0;
        Integer upTotalSize = upList.size();
        //标注不合格的 参数
        List<Point> forMarkPoints = new ArrayList<>();

        while((upi+1) < upList.size()){
            //if((upList.get(upi).getPosition()+1)==upList.get(upi+1).getPosition()){
            //|| upi==(n-1)
            if( isBetween(upList.get(upi),upList.get(upi+1)) || upi==(n-1) ){
                uptime +=1;
                forMarkPoints.add(upList.get(upi));
                if((upi+1)==(upTotalSize-1)){
                    uptime +=1;
                    forMarkPoints.add(upList.get(upi+1));
                }
                //只要到达n 了，就return，防止中间段到达 后面又被重置了
                if(uptime>=n){
                    result = true;
                    //1.
                    for (Point key:forMarkPoints){
                        for(Point j:data){
                            if(key.getPosition().equals(j.getPosition())){
                                j.getUnsatisfiedRules().add(rule2Number);
                                continue;
                            }
                        }
                    }
                    //2.不考虑 return ,先把所有点都找出来。( 重置所有标志位 )
                    uptime = 0;
                }
            }else {
                forMarkPoints = new ArrayList<>();
//                upTotalSize--;
                uptime = 0;
            }
            upi++;
        }


        //下侧的情况
        Integer downi = 0;
        Integer downtime = 0;
        Integer totalSize = downList.size();
        forMarkPoints = new ArrayList<>();
        while((downi+1) < downList.size()){
            //这里之所以 要加上downi==(n-1) 是因为，在比较顺序的时候，要把最后一种可能加上。
            //|| downi==(n-1)
            if(isBetween(downList.get(downi),downList.get(downi+1)) || downi==(n-1) ){
                downtime +=1;
                forMarkPoints.add(downList.get(downi));
                if((downi+1)==(totalSize-1)){
                    downtime++;
                    forMarkPoints.add(downList.get(downi+1));
                }
                if(downtime>=n){
                    result = true;
                    for (Point key:forMarkPoints){
                        for(Point j:data){
                            if(key.getPosition().equals(j.getPosition())){
                                j.getUnsatisfiedRules().add(rule2Number);
                                continue;
                            }
                        }
                    }
                    //2.不考虑 return ,先把所有点都找出来。( 重置所有标志位 )
                    downtime = 0;
                }
            }else {
                forMarkPoints = new ArrayList<>();
//                totalSize--;
                downtime = 0;
            }
            downi++;
        }

        return result;
    }

    /**
     * status : ok
     * name : 规则3
     * desc : 连续 n 点递增或者递减 (默认：6)
     * 注意： 如果存在满足rule3的点，会在原数组 Point.unsatisfiedRules 里标注出来。
     * return :
     *      存在满足rule3的点  =>   true
     *      不存在满足rule3的点  =>   false
     * */
    public static Boolean rule3(List<Point> data, Integer n){

        //递增情况
        Integer upi = 0;
        Integer uptime = 0;
        List<Integer> forMarkKey = new ArrayList<>();
        while((upi+1) < data.size()){
            if((isBetween( data.get(upi),data.get(upi+1) )) && isSmall( data.get(upi),data.get(upi+1) ) ){
                uptime +=1;
                forMarkKey.add(upi);
                if(uptime>=n){
                    for(Integer key:forMarkKey){
                        data.get(key).getUnsatisfiedRules().add(rule3Number);
                    }

                    //不return了, 把所有不满足的点都找出来
//                    return true;
                    uptime = 0;
                }
            }else {
                uptime = 0;
                forMarkKey = new ArrayList<>();
            }
            upi++;
        }


        //递减情况
        Integer downi = 0;
        Integer downtime = 0;
        forMarkKey = new ArrayList<>();
        while((downi+1) < data.size()){
            if((isBetween( data.get(downi),data.get(downi+1) )) && isBig( data.get(downi),data.get(downi+1) ) ){
                downtime +=1;
                forMarkKey.add(downi);
                if(downtime>=n){
                    for(Integer key:forMarkKey){
                        data.get(key).getUnsatisfiedRules().add(rule3Number);
                    }

//                    return true;
                    downtime = 0;
                }
            }else {
                downtime = 0;
                forMarkKey = new ArrayList<>();
            }
            downi++;
        }

        return false;
    }

    /**
     * status : ok
     * name : 规则4
     * desc : 连续 n 点中  相邻点  交替上下 ( 默认：14 ) (n>2)
     * 注意： 如果存在满足rule4的点，会在原数组 Point.unsatisfiedRules 里标注出来。
     * return :
     *      存在满足rule4的点  =>   true
     *      不存在满足rule4的点  =>   false
     * */
    public static Boolean rule4(List<Point> data, Integer n){
        if(n<=2){
            return false;
        }
        Boolean result = false;
        Integer upi = 0;
        Boolean current;
        Boolean nextNeeded;
        Integer times = 0;
        Integer isAgain = 1;
        List<Integer> forMarkKey = new ArrayList<>();
        if(isSmall(data.get(0),data.get(1))){
            current = true;
            nextNeeded = true;
        }else {
            current = false;
            nextNeeded = false;
        }

        while((upi+1) < data.size()){
            if(isBetween( data.get(upi),data.get(upi+1) )){
                //最后一个节点情况
                if((upi+1)==(data.size()-1)){

                    Double u1 = data.get(upi-1).getValueForInterpretation();
                    Double u2 = data.get(upi).getValueForInterpretation();
                    Double u3 = data.get(upi+1).getValueForInterpretation();
                    if(isUpAndDown(u1,u2,u3)){
                        forMarkKey.add(upi);
                        forMarkKey.add(upi+1);
                        times+=2;
                    }
                    if(times >= n){
                        for(Integer key:forMarkKey){
                            data.get(key).getUnsatisfiedRules().add(rule4Number);
                        }

                        //set完了就重置
                        result = true;
                        return result;
                    }
                }


                //formark 最后一个点的时候
                if(forMarkKey.size()==(n-1)){
                    Double u1 = data.get(upi-2).getValueForInterpretation();
                    Double u2 = data.get(upi-1).getValueForInterpretation();
                    Double u3 = data.get(upi).getValueForInterpretation();
                    if(isUpAndDown(u1,u2,u3)){
                        forMarkKey.add(upi);
                        times++;
                    }
                    if(times >= n){
                        for(Integer key:forMarkKey){
                            data.get(key).getUnsatisfiedRules().add(rule4Number);
                        }

                        //set完了就重置
                        result = true;
                        times=0;
                        forMarkKey = new ArrayList<>();

                        //
                        isAgain =2;
                        //
                        continue;
                    }
                }


                //A-B<0   True
                //A-B>0   False
                if(isSmall(data.get(upi),data.get(upi+1))){
                    current = true;
                }else {
                    current = false;
                }
                if(isAgain == 2){
                    nextNeeded = current;
                    isAgain = 1;
                }


                if (current.equals(nextNeeded)){
                    times++;
                    forMarkKey.add(upi);
                    //加入最后一个元素的判断
                    if((upi+1)==(data.size()-1)){
                        Double u0 = data.get(upi - 1).getValueForInterpretation();
                        Double u1 = data.get(upi).getValueForInterpretation();
                        Double u2 = data.get(upi + 1).getValueForInterpretation();
                        if(isUpAndDown(u0,u1,u2)){
                            forMarkKey.add(upi+1);
                            times++;
                        }
                    }


                    if(times >= n){
                        for(Integer key:forMarkKey){
                            data.get(key).getUnsatisfiedRules().add(rule4Number);
                        }
//                        return true;
                        result = true;
                        times=0;
                        forMarkKey = new ArrayList<>();
                        //
                        isAgain =2;
                        //
                        continue;
                    }
                }else {
                    times=0;
                    forMarkKey = new ArrayList<>();
                }
                nextNeeded = !current;
            }else {
                times = 0;
                forMarkKey = new ArrayList<>();
            }
            upi++;
        }

        return result;
    }




    /**
     * name : 规则5
     * desc : 连续 m 点中 有 n 点 落在中心线同一侧，B区以外。( 默认 m:3 , n:2 )
     * 注意：
     *      ① 如果存在满足rule5的点，会在原数组 Point.unsatisfiedRules 里标注出来。
     *      ② 如果如果存在UB外和 LB外的连续 数据也是算的
     * return :
     *      存在满足rule5的点  =>   true
     *      不存在满足rule5的点  =>   false
     *
     * Test status: OK(CaiXiang)
     *
     * */
    private static void rule5Core(List<Point> data,Integer m,Integer n){
        if(data.size() == 0 || data.size() == 1){
            return;
        }

        //开始
        Stack<Point> stack = new Stack<Point>();
        int seqNum = 0;
        int i = 0;
        while((i+1)< data.size()){
            if(stack.size()==0){
                stack.push(data.get(i));
                i++;
                seqNum++;
            }

            Boolean sequence = ((stack.peek().getPosition()+1) == data.get(i).getPosition());
            if( sequence ){
                stack.push(data.get(i));
            }else {
                Boolean stackIsFull = (stack.size()>=n);
                Boolean seqNumIsOK = (seqNum>=m);
                if(stackIsFull && seqNumIsOK){
                    int size = stack.size();
                    for(int s=0;s<size;s++){
                        stack.pop().getUnsatisfiedRules().add(rule5Number);
                    }
                }
                stack.clear();
                stack.push(data.get(i));
            }

            i++;
            seqNum++;
        }
        //判断最后一次情况
        Integer nowi = i>= data.size()?(i-1):i;
        i = nowi;
        Boolean sequence = ((stack.peek().getPosition()+1) == data.get(i).getPosition());
        if( sequence ){
            stack.push(data.get(i));
            seqNum++;
        }else {
            Boolean stackIsFull = (stack.size()>=n);
            Boolean seqNumIsOK = (seqNum>=m);
            if(stackIsFull && seqNumIsOK){
                int size = stack.size();
                for(int s=0;s<size;s++){
                    stack.pop().getUnsatisfiedRules().add(rule5Number);
                }
            }
            stack.clear();
            stack.push(data.get(i));
        }


        Boolean stackIsFull = (stack.size()>=n);
        Boolean seqNumIsOK = (seqNum>=m);
        if(stackIsFull && seqNumIsOK){
            int size = stack.size();
            for(int s=0;s<size;s++){
                stack.pop().getUnsatisfiedRules().add(rule5Number);
            }
        }
        //结束
    }
    public static Boolean rule5(List<Point> data,ControlLimit controlLimit, Integer m, Integer n){
        Boolean result = false;

        List<Point> upforMarkKey = new ArrayList<>();
        List<Point> downforMarkKey = new ArrayList<>();

        ControlLimitDetail controlLimitDetail = new ControlLimitDetail(controlLimit.getUCL(), controlLimit.getCL(), controlLimit.getLCL());
        System.out.println("controlLimitDetail : "+controlLimitDetail.toString());


        //1.先把异常数据都整理出来
//        for(Point i:data){
//            if(i.getValueForInterpretation()>controlLimitDetail.getUB()[1] || i.getValueForInterpretation()<controlLimitDetail.getLB()[0]){
//                upforMarkKey.add(i);
//            }
//        }
        for(Point i:data){
            if(i.getValueForInterpretation()>controlLimitDetail.getUB()[1]){
                upforMarkKey.add(i);
            }
            if(i.getValueForInterpretation()<controlLimitDetail.getLB()[0]){
                downforMarkKey.add(i);
            }
        }

        //2.再用rule5进行分析
        rule5Core(upforMarkKey,m,n);
        rule5Core(downforMarkKey,m,n);

        return result;
    }

    /**
     * name : 规则6
     * desc : 连续 m 点中 有 n 点 落在中心线同一侧，C区以外。( 默认 m:5 , n:4 )
     * 注意： 如果存在满足rule6的点，会在原数组 Point.unsatisfiedRules 里标注出来。
     * return :
     *      存在满足rule6的点  =>   true
     *      不存在满足rule6的点  =>   false
     * Test status: OK(CaiXiang)
     * */
//    public static Boolean rule6(List<Point> data,ControlLimit controlLimit, Integer m, Integer n){
//        Boolean result = false;
//        Integer upi = 0;
//        List<Point> upforMarkKey = new ArrayList<>();
//        List<Point> downforMarkKey = new ArrayList<>();
////        Double[] dataArray = (Double[])data.toArray();
//        Object[] dataArray = data.toArray();
//        ControlLimitDetail controlLimitDetail = new ControlLimitDetail(controlLimit.getUCL(), controlLimit.getCL(), controlLimit.getLCL());
//        System.out.println("controlLimitDetail : "+controlLimitDetail.toString());
//        Boolean lastFlag = false;
//        while(upi < data.size()){
//            Point[] keyList = new Point[m];
//            if(m>=(data.size()-upi)){
//                if(lastFlag){
//                    break;
//                }
//                //System.arraycopy(dataArray , 10 , keyList , 0 , 2 );
//                System.arraycopy(dataArray,upi,keyList,0,(data.size()-upi));
//                lastFlag = true;
//            }else {
//                System.arraycopy(dataArray,upi,keyList,0,m);
//            }
//
//            Integer upTimes = 0;
//            Integer downTimes = 0;
//            for(Point i:keyList){
//                if(i.getValueForInterpretation()>controlLimitDetail.getUC()[1]){
//                    upTimes++;
//                    upforMarkKey.add(i);
//
//                }
//                if(i.getValueForInterpretation()<controlLimitDetail.getLC()[0]){
//                    downTimes++;
//                    downforMarkKey.add(i);
//                }
//            }
//            if(upTimes>=n || downTimes>=n){
//                result = true;
//                if(upTimes>=n){
//                    for(Point i:upforMarkKey){
//
//                        i.getUnsatisfiedRules().add(rule6Number);
//                    }
//                    upforMarkKey = new ArrayList<>();
////                    return true;
//                }
//                if(downTimes>=n){
//                    for(Point i:downforMarkKey){
//                        if(i.getPosition() == 13){
//                            System.out.println(1);
//                        }
//                        i.getUnsatisfiedRules().add(rule6Number);
//                    }
////                    return true;
//                    downforMarkKey = new ArrayList<>();
//                }
//
////                return true;
//            }else {
//                upforMarkKey = new ArrayList<>();
//                downforMarkKey = new ArrayList<>();
//            }
//            upi++;
//        }
//
//
//        return result;
//    }
    private static void rule6Core(List<Point> data,Integer m,Integer n){
        if(data.size() == 0 || data.size() == 1){
            return;
        }
        //开始
        Stack<Point> stack = new Stack<Point>();
        int seqNum = 0;
        int i = 0;
        while((i+1)< data.size()){
            if(stack.size()==0){
                stack.push(data.get(i));
                i++;
                seqNum++;
            }

            Boolean sequence = ((stack.peek().getPosition()+1) == data.get(i).getPosition());
            if( sequence ){
                stack.push(data.get(i));
            }else {
                Boolean stackIsFull = (stack.size()>=n);
                Boolean seqNumIsOK = (seqNum>=m);
                if(stackIsFull && seqNumIsOK){
                    int size = stack.size();
                    for(int s=0;s<size;s++){
                        stack.pop().getUnsatisfiedRules().add(rule6Number);
                    }
                }
                stack.clear();
                stack.push(data.get(i));
            }

            i++;
            seqNum++;
        }
        //判断最后一次情况
        Integer nowi = i>= data.size()?(i-1):i;
        i = nowi;
        Boolean sequence = ((stack.peek().getPosition()+1) == data.get(i).getPosition());
        if( sequence ){
            stack.push(data.get(i));
            seqNum++;
        }else {
            Boolean stackIsFull = (stack.size()>=n);
            Boolean seqNumIsOK = (seqNum>=m);
            if(stackIsFull && seqNumIsOK){
                int size = stack.size();
                for(int s=0;s<size;s++){
                    stack.pop().getUnsatisfiedRules().add(rule6Number);
                }
            }
            stack.clear();
            stack.push(data.get(i));
        }


        Boolean stackIsFull = (stack.size()>=n);
        Boolean seqNumIsOK = (seqNum>=m);
        if(stackIsFull && seqNumIsOK){
            int size = stack.size();
            for(int s=0;s<size;s++){
                stack.pop().getUnsatisfiedRules().add(rule6Number);
            }
        }
        //结束
    }
    public static Boolean rule6(List<Point> data,ControlLimit controlLimit, Integer m, Integer n){
        Boolean result = false;

        List<Point> upforMarkKey = new ArrayList<>();
        List<Point> downforMarkKey = new ArrayList<>();

        ControlLimitDetail controlLimitDetail = new ControlLimitDetail(controlLimit.getUCL(), controlLimit.getCL(), controlLimit.getLCL());
        System.out.println("controlLimitDetail : "+controlLimitDetail.toString());


        //1.先把异常数据都整理出来
//        for(Point i:data){
//            if(i.getValueForInterpretation()>controlLimitDetail.getUB()[1] || i.getValueForInterpretation()<controlLimitDetail.getLB()[0]){
//                upforMarkKey.add(i);
//            }
//        }
        for(Point i:data){
            if(i.getValueForInterpretation()>controlLimitDetail.getUC()[1]){
                upforMarkKey.add(i);
            }
            if(i.getValueForInterpretation()<controlLimitDetail.getLC()[0]){
                downforMarkKey.add(i);
            }
        }

        //2.再用rule5进行分析
        rule6Core(upforMarkKey,m,n);
        rule6Core(downforMarkKey,m,n);

        return result;
    }

    /**
     * name : 规则7
     * desc : 连续 n 点 落在中心线两侧的C区内。( 默认 n:15 )
     * 注意： 如果存在满足rule7的点，会在原数组 Point.unsatisfiedRules 里标注出来。
     * return :
     *      存在满足rule7的点  =>   true
     *      不存在满足rule7的点  =>   false
     * Test status: OK(CaiXiang)
     * */
//    public static Boolean rule7(List<Point> data,ControlLimit controlLimit, Integer n){
//
//        Boolean result = false;
//
//        //Integer upi = 0;
//        ControlLimitDetail controlLimitDetail = new ControlLimitDetail(controlLimit.getUCL(), controlLimit.getCL(), controlLimit.getLCL());
//        System.out.println(controlLimitDetail.toString());
//        Integer times = 0;
//        List<Point> markKey = new ArrayList<>();
//
//
//        for(int i=0;i<data.size();i++){
//            //判断最后一次
//            if((i+1) == data.size()){
//                Point point = data.get(i);
//                if(point.getValueForInterpretation()>controlLimitDetail.getLC()[0] && point.getValueForInterpretation()<controlLimitDetail.getUC()[1]){
//                    times++;
//                    markKey.add(point);
//                    if(times.equals(n)){
//                        for(Point j:markKey){
//                            j.getUnsatisfiedRules().add(rule7Number);
//                        }
//                        return true;
//                    }
//                }else {
//                    times = 0;
//                    markKey = new ArrayList<>();
//                }
//                break;
//            }
//
//            //通常情况
//            Point point = data.get(i);
//            if( isBetween( data.get(i),data.get(i+1) )  ){
//                if(point.getValueForInterpretation()>controlLimitDetail.getLC()[0] && point.getValueForInterpretation()<controlLimitDetail.getUC()[1]){
//                    times++;
//                    markKey.add(point);
//                    if(times.equals(n)){
//                        for(Point j:markKey){
//                            j.getUnsatisfiedRules().add(rule7Number);
//                        }
////                        return true;
//                        result = true;
//                        times = 0;
//                        markKey = new ArrayList<>();
//                    }
//                }else {
//                    times = 0;
//                    markKey = new ArrayList<>();
//                }
//            }else {
//                times = 0;
//                markKey = new ArrayList<>();
//            }
//        }
//        return result;
//    }
    private static void rule7Core(List<Point> data,Integer n){
        if(data.size() == 0 || data.size() == 1){
            return;
        }
        //开始
        Stack<Point> stack = new Stack<Point>();
        int i = 0;
        while((i+1)< data.size()){
            if(stack.size()==0){
                stack.push(data.get(i));
                i++;
            }

            Boolean sequence = ((stack.peek().getPosition()+1) == data.get(i).getPosition());
            if( sequence ){
                stack.push(data.get(i));
            }else {
                Boolean stackIsFull = (stack.size()>=n);

                if(stackIsFull){
                    int size = stack.size();
                    for(int s=0;s<size;s++){
                        stack.pop().getUnsatisfiedRules().add(rule7Number);
                    }
                }
                stack.clear();
                stack.push(data.get(i));
            }

            i++;

        }
        //判断最后一次情况
        Integer nowi = i>= data.size()?(i-1):i;
        i = nowi;
        Boolean sequence = ((stack.peek().getPosition()+1) == data.get(i).getPosition());
        if( sequence ){
            stack.push(data.get(i));

        }else {
            Boolean stackIsFull = (stack.size()>=n);

            if(stackIsFull){
                int size = stack.size();
                for(int s=0;s<size;s++){
                    stack.pop().getUnsatisfiedRules().add(rule7Number);
                }
            }
            stack.clear();
            stack.push(data.get(i));
        }

        Boolean stackIsFull = (stack.size()>=n);

        if(stackIsFull){
            int size = stack.size();
            for(int s=0;s<size;s++){
                stack.pop().getUnsatisfiedRules().add(rule7Number);
            }
        }
        //结束
    }

    public static Boolean rule7(List<Point> data,ControlLimit controlLimit, Integer n){
        Boolean result = false;

//        List<Point> upforMarkKey = new ArrayList<>();
//        List<Point> downforMarkKey = new ArrayList<>();
        List<Point> errforMarkKey = new ArrayList<>();

        ControlLimitDetail controlLimitDetail = new ControlLimitDetail(controlLimit.getUCL(), controlLimit.getCL(), controlLimit.getLCL());
        System.out.println("controlLimitDetail : "+controlLimitDetail.toString());


        //1.先把异常数据都整理出来
        for(Point i:data){
            if(i.getValueForInterpretation()>controlLimitDetail.getLC()[0] && i.getValueForInterpretation()<controlLimitDetail.getUC()[1]){
                errforMarkKey.add(i);
            }
        }


        //2.再用rule5进行分析
        rule7Core(errforMarkKey,n);

        return result;
    }




    /**
     * name : 规则8
     * desc : 连续 n 点 落在中心线两侧，且无一点在C区内。( 默认 n:8 )
     * 注意： 如果存在满足rule8的点，会在原数组 Point.unsatisfiedRules 里标注出来。
     * return :
     *      存在满足rule8的点  =>   true
     *      不存在满足rule8的点  =>   false
     * Test status: OK(CaiXiang)
     * */
//    public static Boolean rule8(List<Point> data,ControlLimit controlLimit, Integer n){
//
//        Boolean result = true;
//        //Integer upi = 0;
//        ControlLimitDetail controlLimitDetail = new ControlLimitDetail(controlLimit.getUCL(), controlLimit.getCL(), controlLimit.getLCL());
//        System.out.println(controlLimitDetail.toString());
//        Integer times = 0;
//        List<Point> markKey = new ArrayList<>();
//
//
//        for(int i=0;i<data.size();i++){
//            //判断最后一次
//            if((i+1) == data.size()){
//                Point point = data.get(i);
//                if( point.getValueForInterpretation()>controlLimitDetail.getUC()[1] || point.getValueForInterpretation()<controlLimitDetail.getLC()[0] ){
//                    times++;
//                    markKey.add(point);
//                    if(times.equals(n)){
//                        for(Point j:markKey){
//                            j.getUnsatisfiedRules().add(rule8Number);
//                        }
//                        return true;
//                    }
//                }else {
//                    times = 0;
//                    markKey = new ArrayList<>();
//                }
//                break;
//            }
//
//            //通常情况
//            Point point = data.get(i);
//            if( isBetween( data.get(i),data.get(i+1) )  ){
//                if( point.getValueForInterpretation()>controlLimitDetail.getUC()[1] || point.getValueForInterpretation()<controlLimitDetail.getLC()[0] ){
//                    times++;
//                    markKey.add(point);
//                    if(times.equals(n)){
//                        for(Point j:markKey){
//                            j.getUnsatisfiedRules().add(rule8Number);
//                        }
//                        result = true;
//                        times = 0;
//                        markKey = new ArrayList<>();
//                    }
//                }else {
//                    times = 0;
//                    markKey = new ArrayList<>();
//                }
//            }else {
//                times = 0;
//                markKey = new ArrayList<>();
//            }
//        }
//        return result;
//    }
    private static void rule8Core(List<Point> data,Integer n){
        if(data.size() == 0 || data.size() == 1){
            return;
        }
        //开始
        Stack<Point> stack = new Stack<Point>();
        int i = 0;
        while((i+1)< data.size()){
            if(stack.size()==0){
                stack.push(data.get(i));
                i++;
            }

            Boolean sequence = ((stack.peek().getPosition()+1) == data.get(i).getPosition());
            if( sequence ){
                stack.push(data.get(i));
            }else {
                Boolean stackIsFull = (stack.size()>=n);

                if(stackIsFull){
                    int size = stack.size();
                    for(int s=0;s<size;s++){
                        stack.pop().getUnsatisfiedRules().add(rule8Number);
                    }
                }
                stack.clear();
                stack.push(data.get(i));
            }

            i++;

        }
        //判断最后一次情况
        Integer nowi = i>= data.size()?(i-1):i;
        i = nowi;
        Boolean sequence = ((stack.peek().getPosition()+1) == data.get(i).getPosition());
        if( sequence ){
            stack.push(data.get(i));

        }else {
            Boolean stackIsFull = (stack.size()>=n);

            if(stackIsFull){
                int size = stack.size();
                for(int s=0;s<size;s++){
                    stack.pop().getUnsatisfiedRules().add(rule8Number);
                }
            }
            stack.clear();
            stack.push(data.get(i));
        }

        Boolean stackIsFull = (stack.size()>=n);

        if(stackIsFull){
            int size = stack.size();
            for(int s=0;s<size;s++){
                stack.pop().getUnsatisfiedRules().add(rule8Number);
            }
        }
        //结束
    }

    public static Boolean rule8(List<Point> data,ControlLimit controlLimit, Integer n){
        Boolean result = false;

//        List<Point> upforMarkKey = new ArrayList<>();
//        List<Point> downforMarkKey = new ArrayList<>();
        List<Point> errforMarkKey = new ArrayList<>();

        ControlLimitDetail controlLimitDetail = new ControlLimitDetail(controlLimit.getUCL(), controlLimit.getCL(), controlLimit.getLCL());
        System.out.println("controlLimitDetail : "+controlLimitDetail.toString());

        //1.先把异常数据都整理出来
        for(Point i:data){
            if(i.getValueForInterpretation()>controlLimitDetail.getUC()[1] && i.getValueForInterpretation()<controlLimitDetail.getLC()[0]){
                errforMarkKey.add(i);
            }
        }


        //2.再用rule5进行分析
        rule8Core(errforMarkKey,n);

        return result;
    }
    /**
     * 如果 这两个点是相邻的  ==》 true
     * */
    private static boolean isBetween(Point head,Point after){
        return (head.getPosition()+1) == after.getPosition();
    }
    /**
     * 如果 head 小于 after ==》  true
     * */
    private static boolean isSmall(Point head,Point after){
        return (head.getValueForInterpretation()- after.getValueForInterpretation()) < 0;
    }
    /**
     * 如果 head 大于 after ==》  true
     * */
    private static boolean isBig(Point head,Point after){
        return (head.getValueForInterpretation()- after.getValueForInterpretation()) > 0;
    }


    /**
     * 如果这三个参数 是起伏的  ====>  true
     *
     * */
    private static boolean isUpAndDown(Double u1,Double u2,Double u3){
        Boolean r1 = ((u1-u2)>0);
        Boolean r2 = ((u2-u3)>0);
        if(!r1.equals(r2)){
            return true;
        }else {
            return false;
        }
    }

}
