package com.cnbm.qualityPlanning.entity;

import lombok.Data;

import java.util.HashSet;
import java.util.Set;

/**
 * @Desc: ""
 * @Author: caixiang
 * @DATE: 2022/7/12 15:12
 */
public class Point {
    private Integer position;
    private Double valueForInterpretation;

    //不满足的 规则   例子 : [1,2]  => 代表 不满足 规则1 和 规则2
    private Set<Integer> unsatisfiedRules;

    public Point(Integer position , Double valueForInterpretation){
        this.position = position;
        this.valueForInterpretation = valueForInterpretation;
        this.unsatisfiedRules = new HashSet();
    }

    public Integer getPosition() {
        return position;
    }

    public void setPosition(Integer position) {
        this.position = position;
    }

    public Double getValueForInterpretation() {
        return valueForInterpretation;
    }

    public void setValueForInterpretation(Double valueForInterpretation) {
        this.valueForInterpretation = valueForInterpretation;
    }

    public Set<Integer> getUnsatisfiedRules() {

        return unsatisfiedRules;
    }

    public void setUnsatisfiedRules(Set<Integer> unsatisfiedRules) {
        this.unsatisfiedRules = unsatisfiedRules;
    }
}
