package com.cnbm.qualityPlanning.service;

import com.cnbm.common.page.PageData;
import com.cnbm.common.service.CrudService;
import com.cnbm.qualityPlanning.dto.ControlGraphDTO;
import com.cnbm.qualityPlanning.entity.ControlGraph;

import java.util.List;
import java.util.Map;

/**
 * 控制图形 表
 *
 * @author why
 * @since  2022-08-15
 */
public interface IControlGraphService extends CrudService<ControlGraph, ControlGraphDTO> {
    PageData<ControlGraphDTO> page (Map<String, Object> params);

    ControlGraphDTO get(Long id);

    void save(ControlGraphDTO dto);

    void update(ControlGraphDTO dto);

    void delete(Long[] ids);

    List<ControlGraphDTO> list();

}