package com.cnbm.qualityPlanning.service;

import com.cnbm.common.page.PageData;
import com.cnbm.common.service.CrudService;
import com.cnbm.qualityPlanning.dto.InterpretationSchemeDTO;
import com.cnbm.qualityPlanning.entity.InterpretationScheme;

import java.util.List;
import java.util.Map;

/**
 * 判读方案 表
 *
 * @author why
 * @since  2022-08-15
 */
public interface IInterpretationSchemeService extends CrudService<InterpretationScheme, InterpretationSchemeDTO> {

    PageData<InterpretationSchemeDTO> page (Map<String, Object> params);

    InterpretationSchemeDTO get(Long id);

    void save(InterpretationSchemeDTO dto);

    void update(InterpretationSchemeDTO dto);

    void batchUpdate(InterpretationSchemeDTO[] lists);

    void delete(Long[] ids);

    List<InterpretationSchemeDTO> list();

    List<InterpretationSchemeDTO> listByMyInterpretationSchemeId(Map<String, Object> params);

    void batchInsert(Long myInterpretationSchemeId);
}