package com.cnbm.qualityPlanning.service;

import com.cnbm.common.page.PageData;
import com.cnbm.common.service.CrudService;
import com.cnbm.qualityPlanning.dto.MyInterpretationSchemeDTO;
import com.cnbm.qualityPlanning.entity.MyInterpretationScheme;

import java.util.Map;

/**
 * 判读方案 表
 *
 * @author why
 * @since  2022-08-15
 */
public interface IMyInterpretationSchemeService extends CrudService<MyInterpretationScheme, MyInterpretationSchemeDTO> {

    PageData<MyInterpretationSchemeDTO> page (Map<String, Object> params);

    MyInterpretationSchemeDTO get(Long id);

    void save(MyInterpretationSchemeDTO dto);

    void update(MyInterpretationSchemeDTO dto);

    void delete(Long[] ids);
    
}